require "minitest/autorun"
require "ucert"

class TestSwiftOnlineTracker < Minitest::Test

  def setup
    @swo_tracker = Ucert::SwiftOnlineTracker.new(:verbose=>false)
  end

  def test_instance_initialize_success
     refute_nil @swo_tracker.file_swo_user_map
     refute_nil @swo_tracker.swo_2_ad_user
     refute_nil @swo_tracker.swo_user_entitlement
  end

#some fields are merged when parse, so the test would fail
  def test_parse_swo_user_entitlement_report
=begin
    file=File.dirname(__FILE__)+"/swift_online_testfiles/UserReport_Test.xlsx"
    @test_swo_user_entitlement=@swo_tracker.send(:parse_swo_user_entitlement_report,file)
    workbook = RubyXL::Parser.parse(file)
    worksheet = workbook[0]
    row=1

    @test_swo_user_entitlement.each do |key, value|
      entitlement_content=value.values
      map_content=Array.new
      0.upto(worksheet[row].size) do |col|
        if worksheet[row][col].nil?
          map_content.push(nil)
        else
          map_content.push(worksheet[row][col].value.to_s)
        end
      end
      puts "There are "+map_content.size.to_s+" columns in testfile"
      puts "There are "+entitlement_content.size.to_s+" columns in swo_user_entitlement"
      assert_equal map_content, entitlement_content
      row+=1
    end
    refute_nil @swo_tracker.file_swo_user_map
=end
  end

  def test_dn_2_index
    #for i in 1..@swo_tracker.swo_user_entitlement.size do
    #  puts i
    #  puts "----------------------------------"
    #  puts @swo_tracker.swo_user_entitlement[i]
    #end
    FileUtils.cp_r(File.dirname(__FILE__)+"/../data/swift_online/swo_access_user_map.txt", File.dirname(__FILE__)+"/swift_online_testfiles/swo_access_user_map_test.txt")
    line_cnt=1
    File.open(File.dirname(__FILE__)+"/swift_online_testfiles/swo_access_user_map_test.txt", 'r').each_line do |line|
      if line_cnt>1
        line.split("|")[1].nil? ? dn="" : dn=line.split("|")[1].strip
        #puts @swo_tracker.swo_user_entitlement[line_cnt-1]["DN"]
        assert_equal line_cnt-1, @swo_tracker.send(:dn_2_index, dn) unless dn.empty?
      end
      line_cnt+=1
    end
    File.delete(File.dirname(__FILE__)+"/swift_online_testfiles/swo_access_user_map_test.txt")
  end

  def test_insert_dn
    @swo_tracker.swo_user_entitlement.each do |index, user|
      dn_regex=/\ACN=.+\,OU=.+\,DC=ny,DC=cmbchina,DC=com\z/
      assert_match dn_regex, user["DN"] unless user["DN"].nil?
    end
  end

  def test_save_swo_user_map!
    @swo_tracker.send(:save!, File.dirname(__FILE__)+"/swift_online_testfiles/swo_access_user_map_test.txt")
    line_count=0
    File.open(File.dirname(__FILE__)+"/swift_online_testfiles/swo_access_user_map_test.txt", 'r').each_line do |line|
      if line_count==0
        assert_match (/\# local Swift Online to AD user map file created by the .+ class .+ method at: .+/), line
      else
        email=line.split("|")[0]
        dn=line.split("|")[1].nil? ? dn="" : dn=line.split("|")[1].strip
        assert_equal @swo_tracker.swo_user_entitlement[line_count]["Mail"].upcase, email
        if dn.empty?
          assert_nil @swo_tracker.swo_user_entitlement[line_count]["DN"]
        else
          assert_equal @swo_tracker.swo_user_entitlement[line_count]["DN"], dn
        end
      end
      line_count+=1
    end
    File.delete(File.dirname(__FILE__)+"/swift_online_testfiles/swo_access_user_map_test.txt")
  end

  def test_swo_search_by_dn
    index=0
    File.open(@swo_tracker.file_swo_user_map, 'r').each_line do |line|
      if index>0
        dn=line.split("|")[1].nil? ? dn="" : dn=line.split("|")[1].strip
        assert_equal dn, @swo_tracker.send(:search_by_dn, dn)['DN'] unless dn.empty?
      end
      index=index+1
    end
  end

  def test_print_user_entitlement
    column_num=Array.new
    @swo_tracker.swo_user_entitlement.values.map do |rec|
      column_num.push(rec.each.size)
    end
    assert_equal 1, column_num.uniq!.size
    $stdout = StringIO.new
    @swo_tracker.print_user.each
    items=$stdout.string.split("\n")
    items.each do |line|
     assert_equal column_num[0], line.count("|")
    end
  end

end
