require "minitest/autorun"
require "ucert"

class TestClass
  include Ucert::Utils
end

class TestUtils < Minitest::Test

  def setup
    @test_instance = TestClass.new
  end

  def test_file_2_list
    test_array=["Test1","Test2","Test3","Test4","Test5"]
    assert_equal test_array, @test_instance.file_2_list(File.dirname(__FILE__)+"/utils_testfiles/file2list_test.txt")
  end

  def test_search_ad
    test_dn="CN=HOAuditor,OU=Disabled Users,OU=New York Branch,DC=ny,DC=cmbchina,DC=com"
    assert_equal test_dn, @test_instance.search_ad("HOAuditor")
  end

  def test_load_known_user_map_from_file
    test_hash={"1"=>"test1", "2"=>"test2", "3"=>"test3"}
    assert_equal test_hash, @test_instance.load_known_user_map_from_file(File.dirname(__FILE__)+"/utils_testfiles/load_know_user_map_testfile.txt")
  end

# ip =~ /\d+\.\d+\.\d+.\d+/ return 0 in method for a valid ip
  def test_is_ip?
    test_ip=["1.1.1.1","192.1.10.1","00.00.0.1","999.0.1.3","11.00.1.","19216818","a.b.c.1","1.1.1.1.1"]
    assert  @test_instance.is_ip?(test_ip[0])
    assert  @test_instance.is_ip?(test_ip[1])
    refute  @test_instance.is_ip?(test_ip[2])
    refute  @test_instance.is_ip?(test_ip[3])
    refute  @test_instance.is_ip?(test_ip[4])
    refute  @test_instance.is_ip?(test_ip[5])
    refute  @test_instance.is_ip?(test_ip[6])
    refute  @test_instance.is_ip?(test_ip[7])
  end

  def test_nslookup
    assert @test_instance.nslookup("www.ruby-lang.org")
  end

end
