#--
# ucert
#
# A  Ruby library for enterprise user account certification / recertification / audit project
#
# Copyright (c) 2015-2016 Yang Li <yli8@yahoo.com>
#++


# -*- encoding: utf-8 -*-
VERSION = File.dirname(__FILE__) + "/version.txt"

# Simple parser for the project version file
info=Hash.new
f=File.open(VERSION,'r')
f.each do |line|
	line.chomp!
	case line
	when /^(\s)*#/
		next
	when /\=/
		entry=line.split("=").map! {|x| x.strip}
		info[entry[0]]=entry[1]
	end
end
f.close
#

Gem::Specification.new do |s|
  s.name = info["package"]
  s.version = info["version"]
  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.authors = info["author"]
  s.homepage = info["linkedin"]
  s.licenses = ["MIT"]
  s.date = info["date"]
  s.description = "ucert is written to perform enterprise user ser account certification / recertification / audit purpse. The user certification data are designed to be automatically tracked by the software."
  s.email = info["email"]
	s.test_files = Dir.glob('test/**/*')
  #s.executables = ["t24_dump", "go_contact_dump"]
	s.executables = Dir['bin/*'].map {|x| x.split('/')[1]}
  s.files = ["CHANGELOG.md", "TODO", "LICENSE.txt","version.txt","README.rdoc", "Rakefile", "ucert.gemspec"]
  s.files += Dir['lib/*'] + Dir.glob('lib/**/*') + Dir['bin/*'] + Dir['demos/*'] + Dir['log/*'] + Dir.glob('data/**/*')
  #s.homepage = "none"
  s.post_install_message = "*"*80 + "\n\nThank you for installing the Ucert gem - a pure Ruby library for Enterprise system user entitlement certification \n / re-certification and tracking. Please refer to the README.rdoc for more information of using this gem.  \n\n" + "*"*80 + "\n"
  s.require_paths = ["lib"]
  s.required_ruby_version = Gem::Requirement.new(">= 1.9.3")
  s.rubyforge_project = "ucert"
  s.rubygems_version = "1.8.24"
  s.summary = "A  Ruby library for enterprise user account certification / recertification / audit project."

end
